<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	Integer[] flowCells = Values.getInt(request.getParameterValues("flowcells"));
	
%>
<base:page id="protocol" type="iframe" favicon="<%=home+"/images/flowcell.png"%>" noskin="true">
<base:head
	scripts="~../reggie-2.js,~flowcell_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css"
	>

	<style>
	h1
	{
		margin-top: 1em;
	}
	
	h2
	{
		margin-bottom: 0;
		font-size: 1.2em;
	}
	
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}
	
	table.flowcell
	{
		min-height: 22em;
		height: 22em;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: middle;
		height: 2.5em;
		max-height: 2.5em;
		border-bottom: 1px solid #000000;
		border-top: 1px solid #000000;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 4px;
		border-right: 1px solid #000000;
	}

	table.protocolheader > tbody > tr > th.subprompt
	{
		text-align: right;
		font-weight: normal;
	}

	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 4px;
	}
	
	.colorbox 
	{
		display: inline-block;
		width: 0.75em; 
		height: 0.75em; 
		border: 1px solid #000000;
		margin-left: 0em;
		margin-right: 0.5em;
	}
	
	.pools
	{
		width: 100%;
		border-collapse: collapse;
	}
	
	.pools tr
	{
		height: 2.5em;
		border-bottom: 1px dotted #666666;
	}

	.pools tr:last-child
	{
		border-bottom: 0;
	}
	
	.pools td, .pools th
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	.pools th
	{
		background-color: #F0F0F0;
		border-bottom: 1px solid #000000;
	}
	
	.pools .lane-no
	{
		width: 5em;
		text-align: center;
	}
	
	.pools .pool-name
	{
		width: 8em;
		text-align: center;
	}
	
	.pool-legend
	{
		width: 8em;
		text-align: center !important;
	}
	
	.green
	{
		background-color: #D8F8D8;
	}
	.green.darker
	{
		background-color: #A0F8A0;
	}
	
	.blue
	{
		background-color: #D8E8FF;
	}
	.blue.darker
	{
		background-color: #B8B8FF;
	}
	
	.yellow
	{
		background-color: #FFFFD8;
	}
	.yellow.darker
	{
		background-color: #FFFFA0;
	}
	
	.red
	{
		background-color: #FFC8C8;
	}
	.red.darker
	{
		background-color: #F8A0A0;
	}
	</style>
</base:head>
<base:body>
	<div class="paper">
	<form name="reggie" id="wizard">
	
	<div id="page-data" class="datacontainer"
		data-flowcells="<%=Values.getString(Arrays.asList(flowCells), ",", true)%>"
	></div>
	
	<div id="wizard-status"></div>
	
	<div id="all-protocol" style="display: none;">

	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<span id="printNote">
		<b>Note!</b> 
		For better printing reduce margins to about <i>5mm</i> and set page orientation
		to <i>portrait</i>.
		</span>
		<br clear="all">
	</div>
	<%
	for (int fcNo = 0; fcNo < flowCells.length; ++fcNo)
	{
		if (fcNo > 0)
		{
			%>
			<div class="pagebreak"></div>
			<%
		}
		%>
		<h1>Lab protocol for sequencing <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

		<table class="protocolheader">
		<tr id="all-pools-<%=fcNo%>">
			<th style="width: 15%;">Used pools</th>
		</tr>
		</table>
		
		<table class="protocolheader flowcell">
		<tr>
			<th style="width: 25%;">Flow cell</th>
			<td style="width: 35%;"><div id="flowCellName.<%=fcNo%>" >Flow cell name <%=fcNo%></div></td>
			<td style="width: 40%; padding: 0; vertical-align: top; border-left: 1px solid #000000;" rowspan="9">
				<table class="pools">
				<tr>
					<th class="lane-no">Lane</th>
					<th class="pool-name">Pool name</th>
					<th class="remarks">Remarks</th>
				</tr>
				<tbody id="pools.<%=fcNo%>"></tbody>
				</table>
			</td>
		</tr>
		<tr>
			<th>Flow cell type</th>
			<td id="flowCellType.<%=fcNo%>"></td>
		</tr>
		<tr>
			<th>Flow cell ID</th>
			<td id="flowCellId.<%=fcNo%>"></td>
		</tr>

		<tr>
			<th>Start date</th>
			<td></td>
		</tr>
		<tr>
			<th>Operator</th>
			<td></td>
		</tr>

		<tr>
			<th>Sequencing machine</th>
			<td></td>
		</tr>
		
		<tr>
			<th>Sequencer position</th>
			<td><b><div class="colorbox"></div>A <span id="pos.b.<%=fcNo%>"><div class="colorbox" style="margin-left: 2em;"></div>__</b></span></td>
		</tr>
		
		<tr>
			<th>Sequencing cycles</th>
			<td><span id="sequencingCycles.<%=fcNo%>"></span> <span style="color: #999999;">(Read1 - Index - Read2)</span></td>
		</tr>
		
		<tr>
			<th>End date+time</th>
			<td></td>
		</tr>
		
		<tr style="height: 10em; vertical-align: top;">
			<th>Comments</th>
			<td id="flowCellDescription.<%=fcNo%>"></td>
		</tr>
		</table>
		
		<%
	}
	%>
	</div>
	</form>
	</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>