var MapData = function()
{
	var map = {};
	var debug = 0;
	
	map.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', map.validateStep1);
		Wizard.initFileSelectionField('file');
		Events.addEventHandler('file', 'change', map.fileChanged);

		Events.addEventHandler('mapFrom', 'change', map.mapFromChanged);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('goexport', Wizard.goRegister);
		Buttons.addClickHandler('godownload', map.download);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', map.submit);
		
		Doc.show('step-1');
		Doc.show('goexport');
		Events.sendChangeEvent('mapFrom');
	}
	
	map.mapFromChanged = function(event)
	{
		var frm = document.forms['reggie'];
		var fromPnr = frm.mapFrom.value == 'PersonalNo';
		
		Doc.showHide('exportPersonalNo', !fromPnr);
		Doc.showHide('exportPatientId', fromPnr);
		Doc.showHide('alsoExportCaseId', fromPnr);
		Doc.showHide('alsoExportSpecimenId', fromPnr);
	}
	
	map.fileChanged = function()
	{
		var frm = document.forms['reggie'];
		var file = frm.file.files[0];
		var reader = new FileReader();
		reader.onload = map.fileLoaded;
		reader.readAsText(file.slice(0, 100000)); // Read at most 100kB -- I think we should get at least 2 lines.... 
	}

	map.fileLoaded = function(event)
	{
		var frm = document.forms['reggie'];
		var data = event.target.result;
		var lines = data.split(/[\n\r]+/);

		var lineNo = 0;
		var mapFrom = null;
		var preview = '';
		while (lineNo < lines.length && lineNo < 5)
		{
			var line = lines[lineNo];
			if (lineNo < 3) 
			{
				preview += Strings.encodeTags(line) + '\n';
			}
			if (mapFrom == null && line.match(/^[QCS]\d+\t.*$/)) // We look for lines starting with 'Q', 'C' or 'S' followed by {digits} and a {tab}
			{
				var firstChar = line.charAt(0);
				if (firstChar == 'Q')
				{
					mapFrom = 'PatientId';
				}
				else if (firstChar == 'C')
				{
					mapFrom = 'CaseId';
				}
				else if (firstChar == 'S')
				{
					mapFrom = 'SpecimenId';
				}
			}
			lineNo++;
		}
		if (lines.length > 3) preview += '<div id="more-lines">+' + (lines.length-3) + ' more lines...</div>';
		frm.mapFrom.value = mapFrom || 'PersonalNo';
		Events.sendChangeEvent(frm.mapFrom);
		Doc.element('preview').innerHTML = preview;
	}

	
	map.validateStep1 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('file');
		if (!valid) event.preventDefault();
	}

	map.submit = function()
	{
		var frm = document.forms['reggie'];
		
		var formData = new FormData();
		var file = frm.file.files[0];
		formData.append('file', file, file.name);

		var url = '../Export.servlet?ID='+App.getSessionId();
		url += '&cmd=MapDataToReleases';
		url += '&mapFrom='+Strings.encodeTags(frm.mapFrom.value);
		url += '&exportCaseId='+(frm.exportCaseId.checked ? 1 : 0);
		url += '&exportSpecimenId='+(frm.exportSpecimenId.checked ? 1 : 0);
		url += '&sortOutput='+(frm.sortOutputOrder.checked ? 1 : 0);
		Wizard.showLoadingAnimation('Working...', 'map-data-progress');
		Wizard.asyncJsonRequest(url, map.submissionResults, 'POST', formData);
	}

	map.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('godownload');
		Doc.show('gorestart');
	}
	
	map.download = function()
	{
		var url = '../Export.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadMappedData';
		location.href = url;
	}

	return map;
}();

Doc.onLoad(MapData.initPage);

